=== include/CMakeLists.txt ===
FILE(GLOB HEADER_FILES "CL/*.h")
FILE(GLOB HPP_FILES "CL/*.hpp")

install (FILES ${HEADER_FILES} DESTINATION include/CL)
install (FILES ${HPP_FILES} DESTINATION include/CL)
