=== debian/changelog ===
beignet (1.3.2-7build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:13:02 +0100

beignet (1.3.2-7) unstable; urgency=medium

  * Remove obsolete transitional package and maintscripts.  (Closes: #939141)
  * Bump Standards-Version to 4.4.1 (no changes needed).
  * Bump debhelper compat to 12 and use debhelper-compat.
  * Switch to LLVM/Clang 9 and fix breakage due to this.
    (Closes: #947435, #948563)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 12 Jan 2020 14:26:20 +0000

beignet (1.3.2-6) unstable; urgency=medium

  * Accept and ignore -g.  (Closes: #881054)
  * Make test dependencies explicit.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 07 Feb 2019 19:16:09 +0000

beignet (1.3.2-5) unstable; urgency=medium

  * Fix another FTBFS with LLVM 7, and use it. (Closes: #912787)
  * Make .pch timestamps reproducible (partial fix for #877359).
  * Clean up properly to allow building multiple times.
  * Don't fail to build if Python 2 is installed.
  * Document that future hardware is likely to require ICR (Neo).
  * Remove obsolete documentation.
  * Update upstream URLs, and recommend reporting bugs to Debian
    rather than upstream.
  * Fix crash in loop unrolling.  (Closes: #913141)
  * Bump Standards-Version to 4.3.0 (no changes needed).
  * Fix beignet-opencl-icd.maintscript syntax bug.
  * README.source: fix bug in suggested test setup.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 10 Jan 2019 19:15:29 +0000

beignet (1.3.2-4) unstable; urgency=medium

  * Fix FTBFS with LLVM 7.
  * Use LLVM 6 everywhere, and document that an explicit version is
    used to require changes to be tested.  (Closes: #906179)
  * Make in-order command queues actually be in-order.
  * Bump Standards-Version to 4.2.1 (no changes needed).
  * utest_run: give clearer errors if hardware not found;
    count crashing as a d/tests fail, not a skip.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 26 Aug 2018 16:35:40 +0100

beignet (1.3.2-3) unstable; urgency=medium

  * Fix memory leak on long event chains.  (LP: #1354086)
  * Fix FTBFS with LLVM 6.
  * Use LLVM 6 on amd64/i386 and 4 on x32.  (Closes: #904279)
  * Allow clCreateCommandQueue to create out-of-order queues.
  * Bump Standards-Version to 4.1.5 (no changes needed).
  * Update cl_accelerator_intel.patch.
  * Bump debhelper compat to 11.
  * Add autopkgtests (skipped in standard setup due to hardware
    requirements - see README.source).
  * Reduce error spew on (partly) unsupported hardware.
  * Enable Coffee Lake hardware support.
  * Update documentation.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 25 Jul 2018 21:17:28 +0100

beignet (1.3.2-2) unstable; urgency=medium

  [ Rebecca N. Palmer ]
  * Remove sometimes-broken optimization.  (Closes: #885423)
  * Don't pointlessly warn on Wayland.  (Closes: #882486)
  * Bump Standards-Version to 4.1.3 (no changes needed).
  * Add d/upstream/metadata.
  * Ship examples.

  [ Andreas Beckmann ]
  * Switch Vcs-* URLs to salsa.debian.org.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 18 Mar 2018 00:36:16 +0100

beignet (1.3.2-1) unstable; urgency=medium

  * New upstream release.  (Closes: #882484)
  * Drop patch applied upstream, refresh others.
  * Fix broken link in documentation.
  * Switch to LLVM 5.0 on release architectures,
    add now-required --link-static to --system-libs.  (Closes: #873403)
  * Fix grammar in documentation.
  * Bump Standards-Version to 4.1.1 (no changes -
    we can't yet be reproducible due to #877359).
  * More user-friendly 'type not supported' messages.
  * Fix whitespace lintian warnings.
  * Set Rules-Requires-Root: no.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 24 Nov 2017 21:17:37 +0100
