=== debian/control ===
Source: beignet
Section: libs
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Simon Richter <sjr@debian.org>,
 Rebecca N. Palmer <rebecca_palmer@zoho.com>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 12),
 cmake (>= 2.8.5),
#If the LLVM version is changed here, it also needs to be changed in d/rules
#3.9 (3.3 with reduced functionality) to 7 are believed to work,
#but as this package cannot run its tests in a standard build,
#specifying an explicit version prevents it from changing
#(due to llvm-defaults changes) without testing
 clang-9,
 libclang-9-dev,
 llvm-9-dev,
 ocl-icd-dev,
 ocl-icd-opencl-dev,
 opencl-headers (>= 2.0~),
 pkg-config,
 python3,
 libdrm-dev,
 libxext-dev,
 libxfixes-dev,
 libx11-dev,
 ikiwiki,
 libtinfo-dev,
 libedit-dev,
 zlib1g-dev,
 libgl1-mesa-dev (>= 13),
 libegl1-mesa-dev (>= 13)
Standards-Version: 4.4.1
Rules-Requires-Root: no
Homepage: https://www.freedesktop.org/wiki/Software/Beignet/
Vcs-Browser: https://salsa.debian.org/opencl-team/beignet
Vcs-Git: https://salsa.debian.org/opencl-team/beignet.git

Package: beignet-opencl-icd
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 x32
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Built-Using: ${Built-Using:clang}
Breaks: beignet0.0.1, beignet (<< 1.0.1)
Replaces: beignet0.0.1, beignet (<< 1.0.1)
Provides: opencl-icd
Description: OpenCL library for Intel GPUs
 OpenCL (Open Computing Language) is a multivendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the shared library for an Intel implementation,
 which supports the integrated GPUs of Ivy Bridge to Coffee Lake
 (ix-3xxx to some ix-8xxx) Intel Core and Atom processors.

Package: beignet-dev
Section: libdevel
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 x32
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
# the testing tool tests the first ICD it finds,
# so allow removing beignet-opencl-icd to test something else
Recommends: beignet-opencl-icd (= ${binary:Version}),
 ocl-icd-opencl-dev
Suggests: opencl-1.2-html-doc
Description: OpenCL for Intel GPUs (development files and documentation)
 OpenCL (Open Computing Language) is a multivendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the documentation specific to this
 implementation, the development files for Intel OpenCL extensions,
 and a (general) OpenCL testing tool.
